x0=zeros(numstates,1);
x0(end)=par.sigmaS;
MX=[eye(length(x0));gx];
IRF_state_sparse=[];
x=x0;
mpar.maxlag=12;

for t=1:mpar.maxlag
    IRF_state_sparse(:,t)=(MX*x)';
    x=hx*x;
end

[~,~,~,~,JD_ss,c_a_star_ss,m_a_star_ss,k_a_star_ss,c_n_star_ss,m_n_star_ss,~,AProb_ss]=F(State,State_m,Contr,Contr_m);
[~,~,~,~,JD_a4,c_a_star_a4,m_a_star_a4,k_a_star_a4,c_n_star_a4,m_n_star_a4,~,AProb_a4]=F(IRF_state_sparse(1:numstates,2),IRF_state_sparse(1:numstates,1),IRF_state_sparse(numstates+1:end,2),IRF_state_sparse(numstates+1:end,1));

%%
[meshes.m,meshes.k,meshes.h] = ndgrid(grid.m,grid.k,grid.h);

c_0=AProb_ss.*c_a_star_ss+(1-AProb_ss).*c_n_star_ss;
m_0=AProb_ss.*m_a_star_ss+(1-AProb_ss).*m_n_star_ss;
k_0=AProb_ss.*k_a_star_ss+(1-AProb_ss).*meshes.k;

[lambdaLI_0,lambdaIL_0,lambdaC_0,lambdaAP_0] = diststats_liquidity(JD_ss,c_0,m_0,k_0,AProb_ss,grid,mpar,par,1);

c_1=AProb_a4.*c_a_star_a4+(1-AProb_a4).*c_n_star_a4;
m_1=AProb_a4.*m_a_star_a4+(1-AProb_a4).*m_n_star_a4;
k_1=AProb_a4.*k_a_star_a4+(1-AProb_a4).*meshes.k;
[lambdaLI_1,lambdaIL_1,lambdaC_1,lambdaAP_1] = diststats_liquidity(JD_a4,c_1,m_1,k_1,AProb_a4,grid,mpar,par,Q(1));

%% Plotting

figurename=['IRF_PortLiquidityGE_theta2_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 500])
plot(20:100,zeros(1,81),'--black')
hold on
plot(21:100,100*((lambdaLI_1(21:end)./lambdaIL_1(21:end))...
    ./(lambdaLI_0(21:end)./lambdaIL_0(21:end))-1),'LineWidth',3)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',20)
xlabel('Percentile of net worth','Interpreter','none','FontName','arial','FontSize',20)
set(gca, 'FontName','arial','FontSize',20);
set(gca,'Position',[0.175 0.15 0.78 0.8])
printpdf(gcf, ['latex\' figurename])

figurename=['IRF_MoneyGE_theta2_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 500])
plot(21:100,100*(lambdaLI_1(21:end)./lambdaLI_0(21:end)-1),'LineWidth',3)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',20)
xlabel('Percentile of net worth','Interpreter','none','FontName','arial','FontSize',20)
hold on
set(gca, 'FontName','arial','FontSize',20);
set(gca,'Position',[0.175 0.15 0.78 0.8])
printpdf(gcf, ['latex\' figurename])

figurename=['IRF_CapitalGE_theta2_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 500])
plot(21:100,100*(lambdaIL_1(21:end)./lambdaIL_0(21:end)-1),'LineWidth',3)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',20)
xlabel('Percentile of net worth','Interpreter','none','FontName','arial','FontSize',20)
hold on
set(gca, 'FontName','arial','FontSize',20);
set(gca,'Position',[0.175 0.15 0.78 0.8])
printpdf(gcf, ['latex\' figurename])

figurename=['IRF_ConsumptionGE_theta2_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 500])
plot(1:100,zeros(1,100),'--black')
hold on
plot(1:100,100*(lambdaC_1(1:end)./lambdaC_0(1:end)-1),'LineWidth',3)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',20)
xlabel('Percentile of net worth','Interpreter','none','FontName','arial','FontSize',20)
hold on
set(gca, 'FontName','arial','FontSize',20);
set(gca,'Position',[0.175 0.15 0.78 0.8])
printpdf(gcf, ['latex\' figurename])
