close all

%% Plotting

figurename=['IRF_Y_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)   '_gamma_T_' num2str(10000*par.gamma_T)  '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_Y,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25);
set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_C_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_C,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_I_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_I,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_G_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_G,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_Deficit_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,Deficit,'LineWidth',3.5)
ylabel('Percentage Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_K_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_K,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_M_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_M,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_H_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_H,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_S_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_S,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])
%%
figurename=['IRF_RBPI_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_RB,'--','LineWidth',3.5)
hold on
plot(1:mpar.maxlag-1,IRF_RBREAL,'LineWidth',3.5)
hold on
legend({'nominal','real'},'Location','NorthEast','AutoUpdate','off')
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_RB_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_RB,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_PI_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_PI,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_Q_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_Q,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_D_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_D,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_LP_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-2,IRF_LP,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])


figurename=['IRF_N_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi)  '_gamma_T_' num2str(10000*par.gamma_T)   '_' casename '_ABS_' num2str(par.ABS*100) '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_N,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

