
%%
load SS_BASELINE_IRF_data
IRF_Y_Baseline=IRF_Y;
IRF_C_Baseline=IRF_C;
IRF_I_Baseline=IRF_I;
IRF_G_Baseline=IRF_G;
IRF_Deficit_Baseline=Deficit;
IRF_K_Baseline=IRF_K;
IRF_M_Baseline=IRF_M;
IRF_N_Baseline=IRF_N;
IRF_S_Baseline=IRF_S;
IRF_PI_Baseline=IRF_PI;
IRF_RB_Baseline=IRF_RB;
IRF_RBREAL_Baseline=IRF_RBREAL;
IRF_Q_Baseline=IRF_Q;
IRF_D_Baseline=IRF_D;
IRF_LP_Baseline=IRF_LP;

%%
load(['IRF_data_' name_1])
IRF_Y_minus=IRF_Y;
IRF_C_minus=IRF_C;
IRF_I_minus=IRF_I;
IRF_G_minus=IRF_G;
IRF_Deficit_minus=Deficit;
IRF_K_minus=IRF_K;
IRF_M_minus=IRF_M;
IRF_N_minus=IRF_N;
IRF_S_minus=IRF_S;
IRF_PI_minus=IRF_PI;
IRF_RB_minus=IRF_RB;
IRF_RBREAL_minus=IRF_RBREAL;
IRF_Q_minus=IRF_Q;
IRF_D_minus=IRF_D;
IRF_LP_minus=IRF_LP;

load(['IRF_data_' name_2])
IRF_Y_plus=IRF_Y;
IRF_C_plus=IRF_C;
IRF_I_plus=IRF_I;
IRF_G_plus=IRF_G;
IRF_Deficit_plus=Deficit;
IRF_K_plus=IRF_K;
IRF_M_plus=IRF_M;
IRF_N_plus=IRF_N;
IRF_S_plus=IRF_S;
IRF_PI_plus=IRF_PI;
IRF_RB_plus=IRF_RB;
IRF_RBREAL_plus=IRF_RBREAL;
IRF_Q_plus=IRF_Q;
IRF_D_plus=IRF_D;
IRF_LP_plus=IRF_LP;


%% Plotting
% Output and Components
figurename=['IRF_Y_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_Y_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag-1,IRF_Y_minus,'--','LineWidth',3.5)
plot(1:mpar.maxlag-1,IRF_Y_plus,'-.','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
legend({legend_baseline,legend_1,legend_2},'Location','SouthEast')
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black','HandleVisibility','off' )
set(gca, 'FontName','arial','FontSize',25);
set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_C_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_C_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag-1,IRF_C_minus,'--','LineWidth',3.5)
plot(1:mpar.maxlag-1,IRF_C_plus,'-.','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag-1),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_I_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_I_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag-1,IRF_I_minus,'--','LineWidth',3.5)
plot(1:mpar.maxlag-1,IRF_I_plus,'-.','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag-1),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_LP_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-2,IRF_LP_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag-2,IRF_LP_minus,'--','LineWidth',3.5)
plot(1:mpar.maxlag-2,IRF_LP_plus,'-.','LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag-1),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])


%%
close all