

No=1;
mpar.T(1,1)=2050;
mpar.T(2,1)=50;

mpar.ns=5;
[sgrid,P_S,boundsS] = Tauchen(par.rhoS,mpar.ns); % LR STD = 1
grid.s       = exp(sgrid*par.sigmaS/sqrt(1-par.rhoS^2));

PS_S=cumsum(P_S,2);
pr_s=rand(RandStream('mcg16807', 'Seed',43215678),1,mpar.T(1,1));
epsilon=randn(RandStream('mcg16807', 'Seed',43215678),mpar.T(1,1),No);
s_cont=zeros(mpar.T(1,1),No);
ss=ones(mpar.T(1,1),No)*ceil(mpar.ns/2); % simulation starts in medium risk regime
x0=zeros(numstates,1);
MX=[eye(length(x0));gx];
IRF_state_sparse=[];
x=x0;
shock=x0;

for i=1:No
    
    for t=2:mpar.T(1,1)
        
        s_cont(t,i) = par.rhoS*s_cont(t-1,i)+par.sigmaS*epsilon(t,i);
        ss(t,i)   = min(mpar.ns,sum(PS_S(ss(t-1,i),:)<pr_s(t))+1);
        x(end)=s_cont(t,i);
        
        
        IRF_state_sparse(:,t,i)=(MX*x)';
        x=hx*x;
    end
    
end

%%

IRF_distr=Gamma_state*IRF_state_sparse(1:numstates-2,:);
% preparation
H=grid.h(1:end-1)*IRF_distr(mpar.nm+mpar.nk+(1:mpar.nh-1),1:end)+par.H;
K=grid.k*IRF_distr(mpar.nm+(1:mpar.nk),:)+grid.K;
I=(K(2:end)-(1-par.delta)*K(1:end-1));
M=grid.m*IRF_distr((1:mpar.nm),2:end)+grid.B;
K=grid.k*IRF_distr(mpar.nm+(1:mpar.nk),2:end)+grid.K;
Kcont=(IRF_distr(end-1,2:end)+1)*grid.K;

HH=H(mpar.T(2,1):mpar.T(1,1)-1)';
Ml=M(mpar.T(2,1):mpar.T(1,1)-1);
M=log(M(mpar.T(2,1):mpar.T(1,1)-1)./grid.B)';
Kl=K(mpar.T(2,1):mpar.T(1,1)-1);
K=log(K(mpar.T(2,1):mpar.T(1,1)-1)./grid.K)';

RB=IRF_state_sparse(numstates-1,mpar.T(2,1):mpar.T(1,1)-1,:)'+par.RB;
RBl=RB;
RB=log(RB./par.RB);
ss_sim=ss(mpar.T(2,1):mpar.T(1,1)-1,:);
Sl=grid.s(ss_sim);

raw_states   = real(log([RBl(:) Ml(:) Kl(:)]));
targets.mean_raw=mean(raw_states,1);
raw_states   = raw_states-repmat(log([par.RB grid.B grid.K]), [max(size(raw_states)) 1]);
COV_states   = cov(raw_states);
[X,L]        = eig(COV_states);
COV_half     = X*sqrt(L);
COV_inv_half = diag(1./sqrt(diag(L)))*X';
Ortho_states = raw_states*COV_inv_half';

cov(Ortho_states)

RB= Ortho_states(:,1);
M = Ortho_states(:,2);
K = Ortho_states(:,3);

ss_cont=s_cont(mpar.T(2,1):mpar.T(1,1)-1,:);

ssfut=ss(mpar.T(2,1)+1:mpar.T(1,1),:);

Q=IRF_state_sparse(end-oc+1,mpar.T(2,1):mpar.T(1,1)-1,:)';
PI=IRF_state_sparse(end-oc+2,mpar.T(2,1):mpar.T(1,1)-1,:)';%./100;

EPI=IRF_state_sparse(end-oc+2,mpar.T(2,1)+1:mpar.T(1,1),:)';%./100;
Y_sim=IRF_state_sparse(end-oc+3,mpar.T(2,1):mpar.T(1,1)-1,:)';
Y_sim_prime=IRF_state_sparse(end-oc+3,mpar.T(2,1)+1:mpar.T(1,1),:)';

EPI=EPI.*((1+Y_sim_prime)./(1+Y_sim));

Profits=IRF_state_sparse(end-oc+7,mpar.T(2,1):mpar.T(1,1)-1,:)';%./100;

%%
% Generate transition probabilities and grid
mpar.nH=3;
maxHH        = (1+1-grid.s(1))*log(par.H);
minHH        = grid.s(1)*log(par.H);
grid.HH      = linspace(-maxHH,-minHH,mpar.nH);%1./(1-par.rhoH^2)+linspace(-2*par.sigmaS/sqrt(factor^2), 2*par.sigmaS/sqrt(factor^2),mpar.nH);
[mH,ms]      = ndgrid(grid.HH,(-grid.s'));
Hplus        = par.rhoH^2*mH + par.sigmaH^2/2 * ms;
Hplus        = exp(Hplus);
grid.H       = exp(grid.HH);

%% Business Cycle stats

Y=Output*(1+IRF_state_sparse(end-oc+3,1:end-1));
G=par.gamma1*(1+IRF_state_sparse(end-oc+4,1:end-1));
Deficit=Ml(1:end-1);
PIaux=(1+PI(1:end-1));
M2=Ml(2:end);
Yaux=Y(mpar.T(2):end-1);
Deficit=(M2(:) - Deficit(:)./PIaux(:))./Yaux(:);
C=(Y-G-I);

[~,Y]=hpfilter(log(Y),1600);
[~,I]=hpfilter(log(I),1600);
[~,C]=hpfilter(log(C),1600);
[~,G]=hpfilter((Deficit),1600);

STDY =[mean(std(Y)); mean(std(C));mean(std(I)); mean(std(G))];
STDY=STDY*100
std(I)/std(Y)

[Y_acf,~,~] = autocorr(Y(:),1);
[C_acf,~,~] = autocorr(C(:),1);
[G_acf,~,~] = autocorr(G(:),1);
[I_acf,~,~] = autocorr(I(:),1);

ACY =[Y_acf(2);C_acf(2);I_acf(2);G_acf(2)];

YY_corr= corrcoef(Y(:),Y(:));
YC_corr= corrcoef(Y(:),C(:));
YG_corr= corrcoef(Y(mpar.T(2):end-1),G(:));
YI_corr= corrcoef(Y(:),I(:));

CORRY = [YY_corr(2,1);YC_corr(2,1);YI_corr(2,1);YG_corr(2,1)];

%% Create Latex Tables
filename=['latex/ModelLineSTD_' casename '_' aggrshock '.tex'];
FID = fopen(filename, 'w');
fprintf(FID, '   %8.2f & %8.2f & %8.2f & %8.2f  \n', STDY);
fclose(FID);

filename=['latex/ModelLineCOR_' casename '_' aggrshock '.tex'];
FID = fopen(filename, 'w');
fprintf(FID, '   %8.2f & %8.2f & %8.2f & %8.2f  \n', CORRY);
fclose(FID);

filename=['latex/Business_cycle_statistics_' casename '_' aggrshock '.tex'];
FID = fopen(filename, 'w');
fprintf(FID, '\\begin{table}[th!] \n');
fprintf(FID, '\\begin{center} \n');
fprintf(FID, '\\begin{threeparttable}  \n');
fprintf(FID, ' \\begin{tabular}{l ccc} \n');

fprintf(FID, '\\\\ \\hline \\hline  \n');
fprintf(FID, ' 	&  STD 	& CORR & AC(1) 	\\\\ \\hline \n');
fprintf(FID, ' Output and Components	&   	& 	\\\\ \\cline{1-1} \n');
fprintf(FID, ' GDP          & %8.2f & %8.2f& %8.2f  \n', STDY(1),CORRY(1),ACY(1));
fprintf(FID, '\\\\Consumption  & %8.2f & %8.2f& %8.2f  \n', STDY(2),CORRY(2),ACY(2));
fprintf(FID, '\\\\Investment       & %8.2f & %8.2f& %8.2f  \n', STDY(3),CORRY(3),ACY(3));
fprintf(FID, '\\\\Gov. deficit& %8.2f & %8.2f& %8.2f  \n', STDY(4),CORRY(4),ACY(4));

fprintf(FID, '\\\\\\\\ \\hline \\ \n');

fprintf(FID, '\\end{tabular} \n');

fprintf(FID, '\\begin{tablenotes}  \n');
fprintf(FID, '\\begin{small} \n');
fprintf(FID, '\\item STD: Standard deviation after log-HP(1600)-filtering multiplied by 100.  \n');
fprintf(FID, '\\item CORR: Correlation with GDP after log-HP(1600)-filtering. \n');
fprintf(FID, '\\item AC(1): First order autocorrelation after log-HP(1600)-filtering. \n');
fprintf(FID, '\\end{small} \n');
fprintf(FID, '\\end{tablenotes}  \n');
fprintf(FID, '\\end{threeparttable}  \n');
fprintf(FID, '\\end{center} \n');
fprintf(FID, '\\end{table} \n');

fclose(FID);

%% Step 9: Update coefficients of LOMinv(A)*B
ss_dummyaux=zeros(size(ss(mpar.T(2,1):mpar.T(1,1)-1,:)));
ss_dummies=NaN(mpar.ns,size(ss_dummyaux(:),1));
ss_aux=ss(mpar.T(2,1):mpar.T(1,1)-1,:);
for j=1:mpar.ns
    ss_dummyaux(ss_aux==j)=1;
    
    ss_dummies(j,:)=ss_dummyaux(:);
    
    ss_dummyaux=zeros(size(ss_aux));
end

ss_dummyaux=zeros(size(ss(mpar.T(2,1)+1:mpar.T(1,1),:)));
ss_dummiesfut=NaN(mpar.ns,size(ss_dummyaux(:),1));
ss_aux=ss(mpar.T(2,1)+1:mpar.T(1,1),:);
for j=1:mpar.ns
    ss_dummyaux(ss_aux==j)=1;
    
    ss_dummiesfut(j,:)=ss_dummyaux(:);
    
    ss_dummyaux=zeros(size(ss_aux));
end



% Regressors
X_EPI=[ss_dummies(2:mpar.ns,:)' repmat(M,[1 mpar.ns]).*ss_dummies' repmat(K,[1 mpar.ns]).*ss_dummies' repmat(RB,[1 mpar.ns]).*ss_dummies' ss_dummiesfut(2:mpar.ns,:)' HH.^-1];

X=[ss_dummies(2:mpar.ns,:)' repmat(M,[1 mpar.ns]).*ss_dummies' repmat(K,[1 mpar.ns]).*ss_dummies' repmat(RB,[1 mpar.ns]).*ss_dummies'  HH.^-1];


% Regressions
statsPI = regstats(real(PI),real(X),'linear',{'beta' 'covb' 'rsquare' 'mse' 'tstat'});
statsEPI = regstats(real(EPI),real(X_EPI),'linear',{'beta' 'covb' 'rsquare' 'mse' 'tstat'});
statsQ = regstats(real(Q),real(X),'linear',{'beta' 'covb' 'rsquare' 'mse','r','tstat'});

% Statistics
R2_PI = statsPI.rsquare;
R2_Q  = statsQ.rsquare;
R2_EPI  = statsEPI.rsquare;


beta_ssfut=statsEPI.beta(4*mpar.ns+1:end-1);
beta_ssfut=[0; beta_ssfut(:)];

Ebeta_ssfut=P_S*beta_ssfut;

clear statsbetaPI_aux statsbetaEPI_aux statsbetaQ_aux
statsPI.beta(2:mpar.ns)=statsPI.beta(2:mpar.ns)+statsPI.beta(1);
statsbetaPI_aux(1,:)=statsPI.beta(1:mpar.ns)';
statsbetaPI_aux(2,:)=statsPI.beta(mpar.ns+1:2*mpar.ns)';
statsbetaPI_aux(3,:)=statsPI.beta(2*mpar.ns+1:3*mpar.ns)';
statsbetaPI_aux(4,:)=statsPI.beta(3*mpar.ns+1:4*mpar.ns)';

statsEPI.beta(2:mpar.ns)=statsEPI.beta(2:mpar.ns)+statsEPI.beta(1);
statsbetaEPI_aux(1,:)=statsEPI.beta(1:mpar.ns)'+Ebeta_ssfut';
statsbetaEPI_aux(2,:)=statsEPI.beta(mpar.ns+1:2*mpar.ns)';
statsbetaEPI_aux(3,:)=statsEPI.beta(2*mpar.ns+1:3*mpar.ns)';
statsbetaEPI_aux(4,:)=statsEPI.beta(3*mpar.ns+1:4*mpar.ns)';

statsQ.beta(2:mpar.ns)=statsQ.beta(2:mpar.ns)+statsQ.beta(1);
statsbetaQ_aux(1,:)=statsQ.beta(1:mpar.ns)';
statsbetaQ_aux(2,:)=statsQ.beta(mpar.ns+1:2*mpar.ns)';
statsbetaQ_aux(3,:)=statsQ.beta(2*mpar.ns+1:3*mpar.ns)';
statsbetaQ_aux(4,:)=statsQ.beta(3*mpar.ns+1:4*mpar.ns)';

statsbetaQ_aux=repmat(statsbetaQ_aux,[1 mpar.nH]);
statsbetaPI_aux=repmat(statsbetaPI_aux,[1 mpar.nH]);
statsbetaEPI_aux=repmat(statsbetaEPI_aux,[1 mpar.nH]);
for j=1:mpar.nH
    statsbetaQ_aux(1,1+(j-1)*mpar.ns:j*mpar.ns)=statsbetaQ_aux(1,1+(j-1)*mpar.ns:j*mpar.ns)+grid.H(j)*statsQ.beta(end);
    statsbetaPI_aux(1,1+(j-1)*mpar.ns:j*mpar.ns)=statsbetaPI_aux(1,1+(j-1)*mpar.ns:j*mpar.ns)+grid.H(j)*statsPI.beta(end);
    statsbetaEPI_aux(1,1+(j-1)*mpar.ns:j*mpar.ns)=statsbetaEPI_aux(1,1+(j-1)*mpar.ns:j*mpar.ns)+grid.H(j)*statsEPI.beta(end);
end


%%
paraux=par;
paraux.beta_PI  = real(statsbetaPI_aux);
paraux.beta_EPI = real(statsbetaEPI_aux);
paraux.beta_q   = real(statsbetaQ_aux);

mparaux=mpar;
mparaux.Kmin=min(Kl(:));
mparaux.Kmax=max(Kl(:));
mparaux.Mmin=min(Ml(:));
mparaux.Mmax=max(Ml(:));
mparaux.RBmin=min(RBl(:));
mparaux.RBmax=max(RBl(:));

R2_Reiter=[R2_PI R2_Q R2_EPI];

switch casename
    case 'SS_BASELINE_KS'
    save LoM_Reiter_Ortho paraux COV_half COV_inv_half mparaux R2_Reiter
end