
%% Welfare Calculations for TwoAsset Baseline Economy

[~,~,~,EU] = ValueFunctionSS(m_n_star,m_a_star,cap_a_star,c_a_guess,c_n_guess,AProb,P_H,mpar,par,grid); % Sum_t \beta^t u(x_t (1+ce)) - Sum_t \beta^t u(x_t) = D_EV <=> (1+ce)^(1-par.xi) EU - EU = DV <=> ce = (DV/EU +1)^(1/(1-par.xi))-1

util  = @(c)(c.^(1-par.xi))./(1-par.xi);
mutil = @(c)(1./(c.^par.xi));
invutil = @(u)(((1-par.xi).*u).^(1/(1-par.xi)));
invmutil = @(mu)((1./mu).^(1/par.xi));

x0=zeros(numstates,1);
x0(end)=par.sigmaS;
MX=[eye(length(x0));gx];
IRF_state_sparse=[];
x=x0;
mpar.maxlag=1;

for t=1:mpar.maxlag
    IRF_state_sparse(:,t)=(MX*x)';
    x=hx*x;
end

pricesel   = size(IRF_state_sparse,1)-[7 6 5];
Priceguess = log([par.Q;par.PI;targets.Y]) +(IRF_state_sparse(pricesel,:));
IRF_distr  = Gamma_state*IRF_state_sparse(1:numstates-2,1:mpar.maxlag);
% preparation
clear Stateguess
Stateguess(1,:)=       IRF_state_sparse(n2(2)+2,:);
Stateguess(2,:)=grid.m*IRF_distr((1:mpar.nm),:)    + grid.B;
Stateguess(3,:)=grid.k*IRF_distr(mpar.nm+(1:mpar.nk),:) + grid.K;
Stateguess(4,:)=grid.h(1:end-1)*IRF_distr(mpar.nm+mpar.nk+(1:mpar.nh-1),:) + par.H;
Stateguess(5,:)=       IRF_state_sparse(n2(2)+1,:) + log(par.RB);

D_EV = - util(Yss(1:n1(1))) + util(Yss(1:n1(1)) .* (1+Gamma_control(1:n1(1),:)*IRF_state_sparse(numstates+1:end,1)));
CE = (D_EV./EU+1).^(1/(1-par.xi))-1;
CEIRF=reshape(100*CE,[mpar.nm mpar.nk mpar.nh]);

CE=CEIRF;


close all

% Money
money_pdf=sum(sum(joint_distr,2),3);
money_cdf=cumsum(money_pdf);
median_money=sum(money_cdf<.5);
pdf_condmoney=squeeze(sum(joint_distr,1));

% Capital
capital_pdf=sum(sum(joint_distr,1),3)';
capital_cdf=cumsum(capital_pdf)';
median_capital=sum(capital_cdf<.5);
pdf_condcapital=squeeze(sum(joint_distr,2));

% Human Capital
humancapital_pdf=squeeze(sum(sum(joint_distr,1),2));
humancapital_cdf=squeeze(cumsum(humancapital_pdf));
median_humancapital=sum(humancapital_cdf<.5);
pdf_condhumancapital=squeeze(sum(joint_distr,3));
pdf_medhumancapital=squeeze((joint_distr(:,:,ceil((mpar.nh-1)/2))))./sum(sum(joint_distr(:,:,ceil((mpar.nh-1)/2))));


%Calculate conditional distributions
for i=1:mpar.nh
    for j=1:mpar.nk
        EU_condm(j,i)=(joint_distr(:,j,i)./sum(joint_distr(:,j,i)))' * CE(:,j,i);
    end
end

for i=1:mpar.nh
    for j=1:mpar.nm
        EU_condk(j,i)=(joint_distr(j,:,i)./sum(joint_distr(j,:,i))) * CE(j,:,i)';
    end
end

for j=1:mpar.nm
    for i=1:mpar.nk
        EU_condh(j,i)=squeeze(joint_distr(j,i,1:end-1)./sum(joint_distr(j,i,1:end-1)))' * squeeze(CE(j,i,1:end-1));
    end
end


%% Tables
EU_aux = squeeze(CE(:,:,:));

AVG=CE(:)'*joint_distr(:);

for m=1:mpar.nm
    EU_aux2=EU_aux(m,:,:);
    JD_aux=joint_distr(m,:,:);
    EU_money(m)=(JD_aux(:)'/sum(JD_aux(:)))*EU_aux2(:);
end
for k=1:mpar.nk
    EU_aux2=EU_aux(:,k,:);
    JD_aux=joint_distr(:,k,:);
    EU_capital(k)=(JD_aux(:)'/sum(JD_aux(:)))*EU_aux2(:);
end
for h=1:mpar.nh
    EU_aux2=EU_aux(:,:,h);
    JD_aux=joint_distr(:,:,h);
    EU_humancapital(h)=(JD_aux(:)'/sum(JD_aux(:)))*EU_aux2(:);
end

money_quintiles=[1 sum(money_cdf<.2);sum(money_cdf<.2)+1 sum(money_cdf<.4);...
    sum(money_cdf<.4)+1 sum(money_cdf<.6); sum(money_cdf<.6)+1 ...
    sum(money_cdf<.8); sum(money_cdf<.8)+1 mpar.nm];
for i=1:5
    if i==1
        welfare_money_all(i) = money_pdf(money_quintiles(i,1):money_quintiles(i,2))'/(money_cdf(money_quintiles(i,2)))* ...
            EU_money(money_quintiles(i,1):money_quintiles(i,2))';
        welfare_money_median_all(i) = money_pdf(money_quintiles(i,1):money_quintiles(i,2))'/(money_cdf(money_quintiles(i,2)))* ...
            EU_aux(money_quintiles(i,1):money_quintiles(i,2),median_capital,median_humancapital);
    else
        welfare_money_all(i) = money_pdf(money_quintiles(i,1):money_quintiles(i,2))'/(money_cdf(money_quintiles(i,2))-money_cdf(money_quintiles(i,1)-1))* ...
            EU_money(money_quintiles(i,1):money_quintiles(i,2))';
        welfare_money_median_all(i) = money_pdf(money_quintiles(i,1):money_quintiles(i,2))'/(money_cdf(money_quintiles(i,2))-money_cdf(money_quintiles(i,1)-1))* ...
            EU_aux(money_quintiles(i,1):money_quintiles(i,2),median_capital,median_humancapital);
    end
end

capital_quintiles=[1 sum(capital_cdf<.2);sum(capital_cdf<.2)+1 sum(capital_cdf<.4);...
    sum(capital_cdf<.4)+1 sum(capital_cdf<.6); sum(capital_cdf<.6)+1 ...
    sum(capital_cdf<.8); sum(capital_cdf<.8)+1 mpar.nk];
for i=1:5
    if i==1
        welfare_capital_all(i) = capital_pdf(capital_quintiles(i,1):capital_quintiles(i,2))'/(capital_cdf(capital_quintiles(i,2)))* ...
            EU_capital(capital_quintiles(i,1):capital_quintiles(i,2))';
        welfare_capital_median_all(i) = capital_pdf(capital_quintiles(i,1):capital_quintiles(i,2))'/(capital_cdf(capital_quintiles(i,2)))* ...
            squeeze(EU_aux(median_money,capital_quintiles(i,1):capital_quintiles(i,2),median_humancapital))';
    else
        welfare_capital_all(i) = capital_pdf(capital_quintiles(i,1):capital_quintiles(i,2))'/(capital_cdf(capital_quintiles(i,2))-capital_cdf(capital_quintiles(i,1)-1))* ...
            EU_capital(capital_quintiles(i,1):capital_quintiles(i,2))';
        welfare_capital_median_all(i) = capital_pdf(capital_quintiles(i,1):capital_quintiles(i,2))'/(capital_cdf(capital_quintiles(i,2))-capital_cdf(capital_quintiles(i,1)-1))* ...
            squeeze(EU_aux(median_money,capital_quintiles(i,1):capital_quintiles(i,2),median_humancapital))';
    end
end


humancapital_quintiles=[1 sum(humancapital_cdf<.33);sum(humancapital_cdf<.33)+1 sum(humancapital_cdf<.66);...
    sum(humancapital_cdf<.66)+1 sum(humancapital_cdf<.99); mpar.nh mpar.nh];
for i=1:4
    if i==1
        welfare_humancapital(i) = humancapital_pdf(humancapital_quintiles(i,1):humancapital_quintiles(i,2))'/humancapital_cdf(humancapital_quintiles(i,2))* ...
            EU_humancapital(humancapital_quintiles(i,1):humancapital_quintiles(i,2))';
        welfare_humancapital_median(i) = humancapital_pdf(humancapital_quintiles(i,1):humancapital_quintiles(i,2))'/humancapital_cdf(humancapital_quintiles(i,2))* ...
            squeeze(EU_aux(median_money,median_capital,humancapital_quintiles(i,1):humancapital_quintiles(i,2)));
    else
        welfare_humancapital(i)= humancapital_pdf(humancapital_quintiles(i,1):humancapital_quintiles(i,2))'/(humancapital_cdf(humancapital_quintiles(i,2))-humancapital_cdf(humancapital_quintiles(i,1)-1))* ...
            EU_humancapital(humancapital_quintiles(i,1):humancapital_quintiles(i,2))';
        welfare_humancapital_median(i) = humancapital_pdf(humancapital_quintiles(i,1):humancapital_quintiles(i,2))'/(humancapital_cdf(humancapital_quintiles(i,2))-humancapital_cdf(humancapital_quintiles(i,1)-1))* ...
            squeeze(EU_aux(median_money,median_capital,humancapital_quintiles(i,1):humancapital_quintiles(i,2)));
    end
end
welfare_worker_median= squeeze(EU_aux(median_money,median_capital,1:end-1))'*(humancapital_pdf(1:end-1)/sum(humancapital_pdf(1:end-1)));
welfare_entrepreneur_median= squeeze(EU_aux(median_money,median_capital,end))*(humancapital_pdf(end)/sum(humancapital_pdf(end)));
welfare_worker= (EU_humancapital(1:end-1))*(humancapital_pdf(1:end-1)/sum(humancapital_pdf(1:end-1)));
welfare_entrepreneur=EU_humancapital(end)*(humancapital_pdf(end)/sum(humancapital_pdf(end)));

% bonds - capital
for B=1:5
    for K=1:5
        welfare_moneycapital(B,K) = sum(sum(pdf_condhumancapital(money_quintiles(B,1):money_quintiles(B,2),capital_quintiles(K,1):capital_quintiles(K,2))/(sum(sum(pdf_condhumancapital(money_quintiles(B,1):money_quintiles(B,2),capital_quintiles(K,1):capital_quintiles(K,2))))).* ...
            EU_condh(money_quintiles(B,1):money_quintiles(B,2),capital_quintiles(K,1):capital_quintiles(K,2))));
        welfare_moneycapital_median(B,K) = sum(sum(pdf_medhumancapital(money_quintiles(B,1):money_quintiles(B,2),capital_quintiles(K,1):capital_quintiles(K,2))...
            /(sum(sum(pdf_medhumancapital(money_quintiles(B,1):money_quintiles(B,2),capital_quintiles(K,1):capital_quintiles(K,2))))).* ...
            squeeze(EU_aux(money_quintiles(B,1):money_quintiles(B,2),capital_quintiles(K,1):capital_quintiles(K,2),median_humancapital))));
    end
end


%% Create Latex Table

filename=['welfaretable_theta_pi_'  num2str(100*par.theta_pi) '_gamma_pi_' num2str(100*par.gamma_pi) '.tex'];
FID = fopen(['latex/' filename], 'w');

fprintf(FID, ' &\\multicolumn{5}{c}{Quintiles of bond holdings}  & &\\multicolumn{4}{c}{Percentiles of human capital} \\\\ \\cline{2-6} \\cline{8-11}  \n');
fprintf(FID, ' & 1.  &	2.  &  3. &  4.	& 5.   & & 0-33  &	33-66  &  66-99 &  Entr.	\\\\ \\cline{2-11} \n');
fprintf(FID, '\\\\ Conditional & %8.2f & %8.2f & %8.2f & %8.2f& %8.2f & & %8.2f & %8.2f & %8.2f & %8.2f \n', welfare_money_all(:)-AVG, welfare_humancapital(:)-AVG);
fprintf(FID, '\\\\ Median  & %8.2f & %8.2f & %8.2f & %8.2f& %8.2f & & %8.2f & %8.2f & %8.2f & %8.2f \n', welfare_money_median_all(:)-AVG, welfare_humancapital_median(:)-AVG);
fprintf(FID, '\\\\ \\\\ & \\multicolumn{5}{c}{Quintiles of capital holdings}  & &\\multicolumn{4}{c}{ } \\\\ \\cline{2-6} \\cline{8-11}  \n');
fprintf(FID, ' &  1.  &	2.  &  3. &  4.	& 5. & &\\multicolumn{4}{c}{Average \\texttt{CE}: %8.2f }	\\\\ \\cline{2-11} \n',AVG);
fprintf(FID, '\\\\ Conditional &%8.2f &%8.2f & %8.2f & %8.2f & %8.2f  \n', welfare_capital_all(:)-AVG);
fprintf(FID, '\\\\ Median & %8.2f& %8.2f & %8.2f & %8.2f & %8.2f \n', welfare_capital_median_all(:)-AVG);

fclose(FID);


%% Plotting
if par.theta_pi==1.25
welfare_moneycapital_median_baseline=welfare_moneycapital_median;
welfare_moneycapital_baseline=welfare_moneycapital;
save welfare_baseline EU welfare_moneycapital_median_baseline welfare_moneycapital_baseline
else
load welfare_baseline

figurename=['Welfare_MKMEDIAN_Graph_theta_pi_'  num2str(100*par.theta_pi) '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 1200 1000])
bar3(welfare_moneycapital_median-welfare_moneycapital_median_baseline)
ylabel('Quintiles Liquid','Interpreter','none','FontName','arial','FontSize',42.5)
xlabel('Quintiles Illiquid','Interpreter','none','FontName','arial','FontSize',42.5)
set(get(gca,'XLabel'),'Units', 'Normalized','Position',[0.6 -.02]);
set(get(gca,'YLabel'),'Units', 'Normalized','Position',[0.3 -.02]);
zlabel('CE','FontSize',35)
set(get(gca,'ZLabel'),'Units', 'Normalized','Position',[-0.045 0.85],'Rotation',360);
set(gca,'FontSize',35,'FontName', 'arial')
zlim([-0.2 0.125])
set(gca,'XTick',[1 2 3 4 5])
set(gca,'YTick',[1 2 3 4 5])
set(gca,'Position',[0.1 0.075 0.865 0.9])
printpdf(gcf,['latex/' figurename])

figurename=['Welfare_MKCOND_Graph_theta_pi_'  num2str(100*par.theta_pi) '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 1200 1000])
bar3(welfare_moneycapital-welfare_moneycapital_baseline)
ylabel('Quintiles Liquid','Interpreter','none','FontName','arial','FontSize',42.5)
xlabel('Quintiles Illiquid','Interpreter','none','FontName','arial','FontSize',42.5)
set(get(gca,'XLabel'),'Units', 'Normalized','Position',[0.6 -.02]);
set(get(gca,'YLabel'),'Units', 'Normalized','Position',[0.3 -.02]);
zlabel('CE','FontSize',35)
set(get(gca,'ZLabel'),'Units', 'Normalized','Position',[-0.045 0.85],'Rotation',360);
set(gca,'FontSize',35,'FontName', 'arial')
zlim([-0.2 0.2])
set(gca,'XTick',[1 2 3 4 5])
set(gca,'YTick',[1 2 3 4 5])
set(gca,'Position',[0.1 0.075 0.865 0.9])
printpdf(gcf,['latex/' figurename])

end
