%% Parameters specific to Krusell-Smith equilibrium with aggr. uncertainty

%% Construct KS grids
% Choose whether to run simulation on more gridpoints via
% interpolation
mpar.nm_sim     = 1*mpar.nm;
mpar.nk_sim     = 1*mpar.nk;

% Grids of aggregate variables M and K
mpar.nK         = 3;         % number of K states
mpar.nM         = 3;         % number of M states

mpar.nM1=3;
mpar.nM2=mpar.nM;
mpar.nM=mpar.nM1*mpar.nM2;

% Number of gridpoints for the uncertainty process
mpar.ns         = 5;
mpar.nH         = 3;
grid.k_sim      = grid.k;
grid.m_sim      = grid.m;

grid.oM          = linspace(-3,3,mpar.nM2);
grid.oRB         = linspace(-3,3,mpar.nM1);
grid.oK          = linspace(-3,3,mpar.nK);

COV_half=diag([0.0015, .05*log(targets.B), .005*log(targets.K)]);
COV_inv_half=inv(COV_half)*eye(3);


%% Guess for Law of Motion
par.beta_q = zeros(4,mpar.ns*mpar.nH);
par.beta_PI = zeros(4,mpar.ns*mpar.nH);
par.beta_EPI = zeros(4,mpar.ns*mpar.nH);
par.beta_PI(1,:) = log(par.PI);
par.beta_EPI(1,:) = log(par.PI);

%% Parameters for Numerical Simulation
mpar.T(1,1)     = 155; % number of periods
mpar.T(2,1)     = 5;  % burn-in phase
mpar.sim_interp=(mpar.nm~=mpar.nm_sim) || (mpar.nk~=mpar.nk_sim);
mpar.nblocks = 40;       % number of independent economies
mpar.crit    = 1e-4;    % stop criterium w.r.t. forecasting rules

% Update weight
mpar.weightlastguess = 0.8;