function [c_new, EMU]=EGM_Step1_a(mutil_c,P,RBRB,P_KM,par,mpar)
%EGM_Step1_a obtains an expression for the marginal utility from
% consumption for a choice m' of end of period money holdings given non-adjustment
% and obtains an update for the consumption policy (given k, h'xs',M',varH).
% The budget constraint is not yet taken into account.
% c_new(m,k,s*h,M,K):   Consumption given m'
% EMU(m,k,s*h,M,K):     Expected marginal utility given m'

% Copyright (c) 2018-05-27
% Christian Bayer, Ralph Luetticke, Lien Pham-Dao, and Volker Tjaden

mutil_c=RBRB.*mutil_c; %take return on money into account

EMU=expect_mex_new(P,P_KM,mutil_c*par.beta);

c_new = 1./(EMU.^(1/par.xi));
end