function E_rhs_psi = EGM_Step5(mutil_c_n,mutil_c_a,psi_guess,P,P_KM,QQ,RR,AProb,par,mpar)
%EGM_Step5 determines the right-hand side of psi as defined in the paper 

% Copyright (c) 2018-05-27
% Christian Bayer, Ralph Luetticke, Lien Pham-Dao, and Volker Tjaden

%% Calculate returns

term1=((AProb.* mutil_c_a .*(QQ + RR))...
    +((1-AProb).* mutil_c_n .* RR)...
    +(1-AProb).* psi_guess);

E_rhs_psi=expect_mex_new(P,P_KM,par.beta*term1);


end

