function [ m_n_prime,c_new ] = KS_EGM_Step1( EMU,RB,PI,W,R,meshes,grid,par,mpar )
%KS_EGM_Step1 returns the current period consumption and money policy 
%in the case of no-adjustment:
%c_new(m,k,h)
%m_n_prime(m,k,h)

% Copyright (c) 2018-05-27
% Christian Bayer, Ralph Luetticke, Lien Pham-Dao, and Volker Tjaden

c_new =1./((par.beta.*EMU).^(1/par.xi));

m_star_n = (c_new + meshes.m - W.*meshes.h - meshes.k*R  - meshes.profits); %money holdings in t conditional on m' choice
m_star_n = (m_star_n<0).*m_star_n./((RB+par.borrwedge)./PI)...
    + (m_star_n>=0).*m_star_n./(RB./PI);

binding_constraints = meshes.m < repmat(m_star_n(1,:,:),[mpar.nm_sim 1 1 ]); % check for binding constraints
m_star_n = reshape(m_star_n,[mpar.nm_sim mpar.nk_sim*mpar.nh]);
c_new= reshape(c_new,[mpar.nm_sim mpar.nk_sim*mpar.nh]);

[~, m_n_prime]=egm1b_aux_mex(grid.m_sim,m_star_n,c_new);
m_n_prime = reshape(m_n_prime,[mpar.nm_sim, mpar.nk_sim, mpar.nh ]);
m_n_prime(binding_constraints) = min(grid.m_sim);
c_new=reshape(c_new,[mpar.nm_sim,mpar.nk_sim,mpar.nh]);
end

