function [ cons_list, res_list, mon_list,cap_list  ] = KS_EGM_Step3( EMU_use2,m_a_star,c_new,Q,W,grid,meshes,mpar,par )
%KS_EGM_Step3 
% Copyright (c) 2018-05-27
% Christian Bayer, Ralph Luetticke, Lien Pham-Dao, and Volker Tjaden

EMU_use2=reshape(EMU_use2,[mpar.nm_sim, mpar.nk_sim*mpar.nh]);

% Interpolation of psi-function at m*_a(k',h)
[~,idx]=histc(m_a_star,grid.m_sim); % find indexes on grid next smallest to optimal policy
idx(m_a_star<=grid.m_sim(1))=1; %if below minimum
idx(m_a_star>=grid.m_sim(end))=mpar.nm_sim-1; %if above maximum

step=diff(grid.m_sim); %Stepsize on grid
dist = (m_a_star - grid.m_sim(idx))./step(idx);%Distance of optimal policy to next grid point

aux_index=(0:(mpar.nk_sim*mpar.nh)-1)*mpar.nm_sim; %aux for linear indexes
joint_index=idx(:)+aux_index(:);

EMU_star = EMU_use2(joint_index) + ...
    dist(:).*(EMU_use2(joint_index+1)-EMU_use2(joint_index)); %linear interpolation

c_star = 1./((par.beta*EMU_star).^(1/par.xi));

cap_expenditure = shiftdim(meshes.k(1,:,:))*Q;
auxL=shiftdim(W(1,:,:)).*shiftdim(meshes.h(1,:,:));

Resource = c_star + m_a_star(:) + cap_expenditure(:) - auxL(:) - meshes.profits;

c_star = reshape(c_star, [mpar.nk_sim mpar.nh]);
Resource = reshape(Resource, [mpar.nk_sim mpar.nh]);

%% If only m-constraint is not binding
m_star_zero=shiftdim(m_a_star(1,:));
% Use consumption at k'=0 from constrained problem, when m' is on grid
aux_c=reshape(c_new(:,1,:),[mpar.nm_sim, mpar.nh]);
aux_inc=reshape(W(1,1,:),[1 mpar.nh]).*reshape(meshes.h(1,1,:),[1 mpar.nh]);
cons_list=cell(mpar.nh,1);
res_list=cell(mpar.nh,1);
mon_list=cell(mpar.nh,1);
cap_list=cell(mpar.nh,1);


for j=1:mpar.nh
    if m_star_zero(j)>grid.m_sim(1)
        log_index=grid.m_sim<m_star_zero(j);
        c_k_cons=aux_c(log_index,j);
        cons_list{j}=c_k_cons; %Consumption at k'=0, m'<m_a*(0)
        % Required Resources: Money choice + Consumption - labor income
        res_list{j}=grid.m_sim(log_index)' + c_k_cons - aux_inc(j) - meshes.profits;
        mon_list{j}=grid.m_sim(log_index)';
        cap_list{j}=zeros(sum(log_index),1);
    end
end

%% Merge lists
c_star=reshape(c_star,[mpar.nk_sim mpar.nh]);
m_a_star=reshape(m_a_star,[mpar.nk_sim mpar.nh]);
Resource=reshape(Resource,[mpar.nk_sim mpar.nh]);
for j=1:mpar.nh
    cons_list{j}=[cons_list{j} ;c_star(:,j)];
    res_list{j}=[ res_list{j};Resource(:,j)];
    mon_list{j}=[ mon_list{j};m_a_star(:,j)];
    cap_list{j}=[cap_list{j}; grid.k_sim'];
end


end

