function [V,EVa,EVn,AProb]=ValueFunction(m_n_star,m_a_star,cap_a_star,c_a_star,c_n_star,AProb,P,P_KM,mpar,par,grid)
%% Value Functions:
%
% Copyright (c) 2018-05-27
% Christian Bayer, Ralph Luetticke, Lien Pham-Dao, and Volker Tjaden

util = @(c)(c.^(1-par.xi))./(1-par.xi);

m_a_star(m_a_star>grid.m(end))=grid.m(end);
m_n_star(m_n_star>grid.m(end))=grid.m(end);
cap_a_star(cap_a_star>grid.k(end))=grid.k(end);

[~,idm_a] = histc(m_a_star,grid.m);
idm_a(m_a_star<=grid.m(1))=1;
idm_a(m_a_star>=grid.m(end))=mpar.nm-1;

[~,idk] = histc(cap_a_star,grid.k);
idk(cap_a_star<=grid.k(1))=1;
idk(cap_a_star>=grid.k(end))=mpar.nk-1;

% Non-adjustment case
[~,idm_n] = histc(m_n_star,grid.m);
idm_n(m_n_star<=grid.m(1))=1;
idm_n(m_n_star>=grid.m(end))=mpar.nm-1;


[V,EVa,EVn]=ValueFunction_mex(int32(idm_n),m_n_star,int32(idm_a),m_a_star,int32(idk),cap_a_star,c_a_star,c_n_star,AProb,grid.m,grid.k,P,P_KM,par.beta,par.xi,par.mu_chi,par.sigma_chi);

Va =util(c_a_star) + EVa;
Vn =util(c_n_star) + EVn;

AProb = max(min(1./(1+exp(-((Va-Vn)-par.mu_chi)./par.sigma_chi)),1-1e-6),1e-6);

end