function [lambdaLI,lambdaIL,lambdaC,lambdaX] = diststats_liquidity_weights_KS(joint_distr,c_prime,x_prime,grid,Q,PI,mpar)
%
% author: Ralph Luetticke
% Date of last change: 2018/05/27

joint_distr=reshape(joint_distr, [mpar.nm mpar.nk mpar.nh]);

for j=1:mpar.nm
    for i=1:mpar.nk
        m_prime(j,i)=squeeze(joint_distr(j,i,:)./sum(joint_distr(j,i,:)))' * squeeze(m_prime(j,i,:));
        k_prime(j,i)=squeeze(joint_distr(j,i,:)./sum(joint_distr(j,i,:)))' * squeeze(k_prime(j,i,:));
        c_prime(j,i)=squeeze(joint_distr(j,i,:)./sum(joint_distr(j,i,:)))' * squeeze(c_prime(j,i,:));
        x_prime(j,i)=squeeze(joint_distr(j,i,:)./sum(joint_distr(j,i,:)))' * squeeze(x_prime(j,i,:));
        
    end
end

[mesh.k,mesh.m]=meshgrid(Q*grid.k,grid.m);
mplusk=mesh.k(:)+mesh.m(:);
[mplusk, IX]=sort(mplusk);

mfull=m_prime(IX);
kfull=k_prime(IX);
cfull=c_prime(IX);
xfull=x_prime(IX);

moneycapital_pdf=max(sum(joint_distr,3),0);
moneycapital_pdf=moneycapital_pdf(IX);
moneycapital_cdf=cumsum(moneycapital_pdf);


% Select percentiles
P=100;
%%
% Select smoothing parameter
h=0.05;

lambda=ones(P,1);
lambdaLI=ones(P,1);
lambdaIL=ones(P,1);
lambdaC=ones(P,1);
lambdaX=ones(P,1);


data=[mplusk(:) mfull kfull moneycapital_cdf moneycapital_pdf*100 cfull xfull];
data(data(:,5)==0,:)=[]; %drop combinations with zero prob
Y=(data(:,2))./(data(:,1)); % minus: obtain li/il ratio
YLI=(data(:,2)); % Liquid assets
YIL=(data(:,3)); % Illiquid assets
C=(data(:,6)); % Illiquid assets
XC=(data(:,7)); % Illiquid assets


for j=1:P
    
    dist=data(:,4)-j/P-0.5/P;
    weight=sqrt(normpdf(dist/h)).*sqrt(data(:,5));
    X=[weight dist.*weight];
    
    beta=regress(Y.*weight,X);
    lambda(j)=beta(1);
    beta=regress(YLI.*weight,X);
    lambdaLI(j)=(beta(1));
    beta=regress(YIL.*weight,X);
    lambdaIL(j)=(beta(1));
    beta=regress(C.*weight,X);
    lambdaC(j)=(beta(1));
    beta=regress(XC.*weight,X);
    lambdaX(j)=(beta(1));
end


end