function [ N,R_fc,W_fc,Profits_fc,WW,RR,QQ,PIPI,RBRB,Y ] = factor_returns(PI,EPI,RB_1,q,K_aux,K_next,grid,par,mpar)
%factor_returns Summary of this function goes here
    % Arguments of R_fc,W_fc:
    %   Dimension 1: current s
    %   Dimension 2: current aggregate M
    %   Dimension 3: current aggregate K
   
    mc =  par.mu - (par.beta * EPI - log(PI))/par.kappa;

        
%%  GHH Preferences    
    N    =  (par.tau.*par.alpha.*K_aux.^(1-par.alpha).*mc).^(1/(1-par.alpha+par.gamma));   
    W_fc =  par.alpha .*mc.* (K_aux./(N)).^(1-par.alpha);
    
    % Before tax return on capital
    R_fc =  (1-par.alpha) .*mc.* ((N)./K_aux).^(par.alpha)- par.delta;
 
    Y = (N).^(par.alpha).*K_aux.^(1-par.alpha);
    Profits_fc = (1-mc).*Y + 1/2*par.phi*((K_next-K_aux).^2)./K_aux - Y.*((1/(1-par.mu)/par.kappa)./2) .*log(PI).^2;
    Profits_fc(Profits_fc<0) = 1e-10;
    
    meshHH=reshape(repmat(grid.H,[mpar.ns/mpar.nH 1 mpar.nM1*mpar.nM2 mpar.nK]),[mpar.ns mpar.nM1*mpar.nM2 mpar.nK]);

    NW=par.gamma/(1+par.gamma).*(N.*meshHH).*W_fc;
    WW=reshape(permute(repmat(NW,[1 1 1 mpar.nh mpar.nm mpar.nk])...
        ,[5 6 1 4 2 3]),[mpar.nm mpar.nk mpar.ns mpar.nh mpar.nM mpar.nK ]); %Wages
    Profits=reshape(permute(repmat(Profits_fc*par.profitshare,[1 1 1 mpar.nh mpar.nm mpar.nk])...
        ,[5 6 1 4 2 3]),[mpar.nm mpar.nk mpar.ns mpar.nh mpar.nM mpar.nK ]); %Wages
    WW(:,:,:,end,:,:)=Profits(:,:,:,end,:,:);
    WW=reshape(WW,[mpar.nm mpar.nk mpar.ns*mpar.nh mpar.nM mpar.nK ]);
    RR=reshape(permute(repmat(R_fc,[1 1 1 mpar.nh mpar.nm mpar.nk])...
        ,[5 6 1 4 2 3]),[mpar.nm mpar.nk mpar.ns*mpar.nh mpar.nM mpar.nK ]); %Rental rates
    QQ=reshape(permute(repmat(q,[1 1 1 mpar.nh mpar.nm mpar.nk])...
        ,[5 6 1 4 2 3]),[mpar.nm mpar.nk mpar.ns*mpar.nh mpar.nM mpar.nK ]); %Capital price
    PIPI=reshape(permute(repmat(PI,[1 1 1 mpar.nh mpar.nm mpar.nk])...
        ,[5 6 1 4 2 3]),[mpar.nm mpar.nk mpar.ns*mpar.nh mpar.nM mpar.nK ]); %Inflation
    RBRB= reshape(permute(repmat(((RB_1./PI)),[1 1 1 mpar.nh mpar.nm mpar.nk])...
        ,[5 6 1 4 2 3]),[mpar.nm mpar.nk mpar.ns*mpar.nh mpar.nM mpar.nK ]); 
    RBRBbor= reshape(permute(repmat((((RB_1+par.borrwedge)./PI)),[1 1 1 mpar.nh mpar.nm mpar.nk])...
        ,[5 6 1 4 2 3]),[mpar.nm mpar.nk mpar.ns*mpar.nh mpar.nM mpar.nK ]); 
    RBRB(grid.m<0,:,:,:,:)=RBRBbor(grid.m<0,:,:,:,:);

end

