function [ss,M,PI,EPI,K,Q,RB,H,R,W,mc,TaxRev,Y,C,I,G,N,BC,Profits,AP,lambdaLI,lambdaIL,lambdaC,lambdaX]=kssimulation_2Assets(c_n_guess,c_a_guess,psi_guess,EVa,EVn,...
    P,P_S,P_H,AProb,joint_distr,grid,QQ,RR,RBRB,seed,mpar,par,targets,thread,sim_mode,COV_half,COV_inv_half)
%kssimulation_2Assets simulates the model given the policies. It gives back
%time series on aggregate states and prices:
%{M,ss,PI,K,Q} with dimension mpar.T(1,1)

% Copyright (c) 2018-05-27
% Christian Bayer, Ralph Luetticke, Lien Pham-Dao, and Volker Tjaden

switch sim_mode
    case 'IRF'
        
        [sgrid,P_S,boundsS] = Tauchen(par.rhoS,mpar.ns); % LR STD = 1
        PS_S=cumsum(P_S,2);
        pr_s=rand(RandStream('mcg16807', 'Seed',seed),1,mpar.T(1,1));
        epsilon=randn(RandStream('mcg16807', 'Seed',seed),1,mpar.T(1,1))*sqrt(1-par.rhoS^2);
        s_cont=zeros(1,mpar.T(1,1));
        
        ss=ones(1,mpar.T(1,1))*ceil(mpar.ns/2); % simulation starts in medium risk regime
        
        
    otherwise
        PS_S=cumsum(P_S,2);
        pr_s=rand(RandStream('mcg16807', 'Seed',seed),1,mpar.T(1,1));
        ss=ones(1,mpar.T(1,1))*ceil(mpar.ns/2); % simulation starts in medium risk regime
        
end

M=nan(1,mpar.T(1,1));
M(1,1:2)= targets.B;
PI=nan(1,mpar.T(1,1));
PI(1,1:2)=par.PI;   
EPI=nan(1,mpar.T(1,1));
RB=nan(1,mpar.T(1,1));
RB(1,1:2)=par.RB;
K=nan(1,mpar.T(1,1));
K(1,1:2)= targets.K;
Q=nan(1,mpar.T(1,1));
Q(1,1:2)=1;    
TaxRev=nan(1,mpar.T(1,1));
Profits=nan(1,mpar.T(1,1));
BC=nan(1,mpar.T(1,1));
mc=nan(1,mpar.T(1,1));
W=nan(1,mpar.T(1,1));
R=nan(1,mpar.T(1,1));
Y=nan(1,mpar.T(1,1));
I=nan(1,mpar.T(1,1));
N=nan(1,mpar.T(1,1));
H=nan(1,mpar.T(1,1));
G=nan(1,mpar.T(1,1));
AP=nan(1,mpar.T(1,1));
C=nan(3,mpar.T(1,1));
lambdaLI=nan(4,100);
lambdaIL=nan(4,100);
lambdaC=nan(4,100);
lambdaX=nan(4,100);

mutil_c_n = 1./(c_n_guess.^par.xi); % marginal utility at consumption policy no adjustment
mutil_c_a = 1./(c_a_guess.^par.xi); % marginal utility at consumption policy adjustment
mutil_c = AProb.*mutil_c_a + (1-AProb).*mutil_c_n; % Expected marginal utility at consumption policy (w &w/o adjustment)

% Terms for optimal money adjustment in no capital adjustment case
aux=reshape(permute(RBRB.*mutil_c,[3 1 2 4 5]),[mpar.ns*mpar.nH*mpar.nh mpar.nm*mpar.nk*mpar.nM*mpar.nK]);
% form expectations
aux = permute(reshape(P*aux,[mpar.ns*mpar.nH mpar.nh mpar.nm mpar.nk mpar.nM mpar.nK]),[3 4 1 2 5 6]);
EMU = aux;

% Terms in Step 2 (Money adjustment in adjustment case)
aux=reshape(permute(AProb.*mutil_c_a.*(QQ+RR) + (1-AProb).*mutil_c_n.*(RR) + (1-AProb).*psi_guess,[3 1 2 4 5]),[mpar.ns*mpar.nH*mpar.nh mpar.nm*mpar.nk*mpar.nM*mpar.nK]);
% form expectations
aux = permute(reshape(P*aux,[mpar.ns*mpar.nH mpar.nh mpar.nm mpar.nk mpar.nM mpar.nK]),[3 4 1 2 5 6]);
LHS_term_Step2 = aux;
[meshes.m,meshes.k,meshes.h]=ndgrid(grid.m_sim,grid.k_sim,grid.h);

k_n_prime=meshes.k;

EMU=reshape(EMU,[mpar.nm mpar.nk mpar.ns mpar.nH mpar.nh mpar.nM1 mpar.nM2 mpar.nK]);
LHS_term_Step2=reshape(LHS_term_Step2,[mpar.nm mpar.nk mpar.ns mpar.nH mpar.nh mpar.nM1 mpar.nM2 mpar.nK]);
EVa=reshape(EVa,[mpar.nm mpar.nk mpar.ns mpar.nH mpar.nh mpar.nM1 mpar.nM2 mpar.nK]);
EVn=reshape(EVn,[mpar.nm mpar.nk mpar.ns mpar.nH mpar.nh mpar.nM1 mpar.nM2 mpar.nK]);


for t=3:mpar.T(1,1)
    
    switch sim_mode
        case 'IRF'
            
            if t==mpar.T(2,1) && mpar.shock==1
                s_cont(t) = par.rhoS*s_cont(t-1)+1*sqrt(1-par.rhoS^2);
            else
                s_cont(t) = par.rhoS*s_cont(t-1);
            end
            
            [~,ss(t)] = histc(s_cont(t)',boundsS);
            
            
        otherwise
            ss(t)   = min(mpar.ns,sum(PS_S(ss(t-1),:)<pr_s(t))+1);
            
    end
    
    H(t)  = sum(sum(sum(meshes.h(:,:,1:end-1).*joint_distr(:,:,1:end-1)))); %Last column is entrepreneurs.
    
    Hplus=par.rhoH^2*log(H(t)) + par.sigmaH^2/2 * grid.s(ss(t));
    Hplus=exp(-Hplus);
    
    [~,idH]=histc(Hplus,grid.H);
    idH(Hplus>=grid.H(end)) = mpar.nH-1;
    idH(Hplus<=grid.H(1))   = 1;
    
    distH=(Hplus - grid.H(idH))/(grid.H(idH+1) - grid.H(idH));
    
    SS_interp = zeros(mpar.nH*mpar.ns,1);
    SS_interp(ss(t)+(idH-1)*mpar.ns)=(1-distH);
    SS_interp(ss(t)+(idH)*mpar.ns)=distH;
    
    EMU_use= squeeze(EMU(:,:,ss(t),:,:,:,:,:));
    LHS_use= squeeze(LHS_term_Step2(:,:,ss(t),:,:,:,:,:));
    EVa_use= squeeze(EVa(:,:,ss(t),:,:,:,:,:));
    EVn_use= squeeze(EVn(:,:,ss(t),:,:,:,:,:));
    
    EMU_use= squeeze(EMU_use(:,:,idH,:,:,:,:)) + ...
        distH*(squeeze(EMU_use(:,:,idH+1,:,:,:,:))- squeeze(EMU_use(:,:,idH,:,:,:,:)));
    LHS_use= squeeze(LHS_use(:,:,idH,:,:,:,:)) + ...
        distH*(squeeze(LHS_use(:,:,idH+1,:,:,:,:))- squeeze(LHS_use(:,:,idH,:,:,:,:)));
    EVa_use= squeeze(EVa_use(:,:,idH,:,:,:,:)) + ...
        distH*(squeeze(EVa_use(:,:,idH+1,:,:,:,:))- squeeze(EVa_use(:,:,idH,:,:,:,:)));
    EVn_use= squeeze(EVn_use(:,:,idH,:,:,:,:)) + ...
        distH*(squeeze(EVn_use(:,:,idH+1,:,:,:,:))- squeeze(EVn_use(:,:,idH,:,:,:,:)));    
    
    O_next = (log([RB(t-1) M(t-1) K(t-1)])-targets.mean_raw)*COV_inv_half';
    PI_forecast    = exp(SS_interp'*(par.beta_PI(1,:) + par.beta_PI(2,:).*(O_next(2)) + par.beta_PI(3,:)*(O_next(3)) + par.beta_PI(4,:)*(O_next(1)))');
    q_forecast     = exp(SS_interp'*(par.beta_q(1,:) + par.beta_q(2,:).*(O_next(2)) + par.beta_q(3,:)*(O_next(3))+ par.beta_q(4,:)*(O_next(1)))');
    

    bonds=@(PriceGuess)ExcessDemand(PriceGuess,M(t-1),RB(t-1),EMU_use,LHS_use,EVa_use,EVn_use,joint_distr,...
        grid,meshes, K(t-1),H(t),SS_interp,k_n_prime, mpar,par,targets,COV_half,COV_inv_half);
    
    Guess=[PI_forecast q_forecast];

    options=optimset('Display','off','TolFun',mpar.crit,'TolX',mpar.crit);
    
    [PriceClear,funct,exitflag,output]= fsolve(bonds,Guess,options);
    
    
    %% Step  Update Aggregates
    % Re-run Step 1-5 with market clearing inflation rate
    [ED,m_n_prime,m_a_prime,k_a_prime,c_n_prime,c_a_prime,x_n_prime,x_a_prime,AProb,RB(t),M(t),K(t),mc(t),W(t),R(t),Y(t),N(t),TaxRev(t),Profits(t),G(t)]=bonds(PriceClear);
   
    PI(t)   =   PriceClear(1); % current market clearing inflation
    Q(t)    =   PriceClear(2);
    
    I(t) = K(t) - (1-par.delta)*K(t-1);
    C(2,t) = sum(AProb(:).*joint_distr(:).*c_a_prime(:)) + sum((1-AProb(:)).*joint_distr(:).*c_n_prime(:));
    C(3,t) = sum(AProb(:).*joint_distr(:).*x_a_prime(:)) + sum((1-AProb(:)).*joint_distr(:).*x_n_prime(:));
    C(1,t) = Y(t) - G(t) -I(t);
    
    EPI(t-1) = log(PI(t))*Y(t)/Y(t-1);
    
    AP(t)=mean(AProb(:));
    
    switch sim_mode
        case 'IRF'
            if t>=mpar.T(2,1) && t<=mpar.T(2,1)+3
                [lambdaLI(t-mpar.T(2,1)+1,:),lambdaIL(t-mpar.T(2,1)+1,:),lambdaC(t-mpar.T(2,1)+1,:),lambdaX(t-mpar.T(2,1)+1,:)] = diststats_liquidity_weights_KS(joint_distr,AProb(:).*c_a_prime(:) + (1-AProb(:)).*c_n_prime(:),AProb(:).*x_a_prime(:) + (1-AProb(:)).*x_n_prime(:),grid,Q(t),1,mpar);
            end
    end
    
    %% Step Update Distribution
    joint_distr=reshape(joint_distr,[mpar.nm_sim*mpar.nk_sim, mpar.nh]);
    
    % policy transitions
    % Adjustment case
    [~,idm_a] = histc(m_a_prime,grid.m_sim);
    idm_a(m_a_prime<=grid.m_sim(1))=1;
    idm_a(m_a_prime>=grid.m_sim(end))=mpar.nm_sim-1;
    
    [~,idk_a] = histc(k_a_prime,grid.k_sim);
    idk_a(k_a_prime<=grid.k_sim(1))=1;
    idk_a(k_a_prime>=grid.k_sim(end))=mpar.nk_sim-1;
    
    % Non-adjustment case
    [~,idm_n] = histc(m_n_prime,grid.m_sim);
    idm_n(m_n_prime<=grid.m_sim(1))=1;
    idm_n(m_n_prime>=grid.m_sim(end))=mpar.nm_sim-1;
    
    idk_n = repmat(ones(mpar.nm_sim,1)*(1:mpar.nk_sim),[1 1 mpar.nh]); %This is the actual point on grid
    
    %% Calculate disances to next on-grid points for off-grid policy
    Dist_m_a = (m_a_prime-grid.m_sim(idm_a))./(grid.m_sim(idm_a+1)-grid.m_sim(idm_a)); % weight xm of higher gridpoint
    Dist_k = (k_a_prime-grid.k_sim(idk_a))./(grid.k_sim(idk_a+1)-grid.k_sim(idk_a)); % weight xk of higher gridpoint
    
    Dist_m_n = (m_n_prime-grid.m_sim(idm_n))./(grid.m_sim(idm_n+1)-grid.m_sim(idm_n)); % weight xm of higher gridpoint
    
    
    Dist_m_a(Dist_m_a<=0)=1.e-16; % no extrapolation
    Dist_m_a(Dist_m_a>=1)=1-1.e-16; % no extrapolation
    
    Dist_k(Dist_k<=0)=1.e-16;   % no extrapolation
    Dist_k(Dist_k>=1)=1-1.e-16; % no extrapolation
    
    Dist_m_n(Dist_m_n<=0)=1.e-16; % no extrapolation
    Dist_m_n(Dist_m_n>=1)=1-1.e-16; % no extrapolation
    
    %% Transition matrix adjustment case
    idh=kron(1:mpar.nh,ones(1,mpar.nm_sim*mpar.nk_sim));
    index11 = sub2ind([mpar.nm_sim mpar.nk_sim mpar.nh],idm_a(:),idk_a(:),idh(:));
    index12 = sub2ind([mpar.nm_sim mpar.nk_sim mpar.nh],idm_a(:),idk_a(:)+1,idh(:));
    index21 = sub2ind([mpar.nm_sim mpar.nk_sim mpar.nh],idm_a(:)+1,idk_a(:),idh(:));
    index22 = sub2ind([mpar.nm_sim mpar.nk_sim mpar.nh],idm_a(:)+1,idk_a(:)+1,idh(:));
    weight21 =  Dist_m_a.*(1-Dist_k);
    weight11 = (1-Dist_m_a).*(1-Dist_k);
    weight22 =  (Dist_m_a).*(Dist_k);
    weight12 =  (1-Dist_m_a).*(Dist_k);
    rowindex=repmat(1:mpar.nm_sim*mpar.nk_sim*mpar.nh,[1 4]);
    
    H_a=sparse(rowindex(:),[index11(:); index21(:); index12(:); index22(:)],...
        [weight11(:); weight21(:); weight12(:); weight22(:)],mpar.nm_sim*mpar.nk_sim*mpar.nh,mpar.nm_sim*mpar.nk_sim*mpar.nh); % mu'(h',k'), a without interest
    
    %% Policy Transition Matrix for no-adjustment case
    
    index11 = sub2ind([mpar.nm_sim mpar.nk_sim mpar.nh],idm_n(:),idk_n(:),idh(:));
    index21 = sub2ind([mpar.nm_sim mpar.nk_sim mpar.nh],idm_n(:)+1,idk_n(:),idh(:));
    
    %Corresponding weights
    weight21 =  Dist_m_n;
    weight11= (1-Dist_m_n);
    rowindex=repmat(1:mpar.nm_sim*mpar.nk_sim*mpar.nh,[1 2]);
    
    H_n=sparse(rowindex,[index11(:); index21(:)],...
        [weight11(:); weight21(:)],mpar.nm_sim*mpar.nk_sim*mpar.nh,mpar.nm_sim*mpar.nk_sim*mpar.nh); % mu'(h',k'), a without interest
    
    APD_a=sparse(1:length(AProb(:)),1:length(AProb(:)),AProb(:));
    APD_n=sparse(1:length(AProb(:)),1:length(AProb(:)),1-AProb(:));
    H_all=APD_a*H_a + APD_n*H_n;
    
    
    %%
    joint_distr_next=(joint_distr(:)'*H_all);
    
    % stochastic transition
    joint_distr_next=reshape(joint_distr_next,[mpar.nm_sim*mpar.nk_sim, mpar.nh])*P_H(:,:,ss(t));
    
    aux=sum(joint_distr_next(:));
    joint_distr_next=joint_distr_next./aux;
    
    joint_distr=reshape(joint_distr_next,[mpar.nm mpar.nk mpar.nh]);
end

end
