
robustness='KS';
legend_1=['Baseline (Reiter)'];
legend_2=['Krusell-Smith'];
%%
load('../Baseline/SS_BASELINE_IRF_data.mat')

IRF_Y_Baseline=IRF_Y;
IRF_C_Baseline=IRF_C;
IRF_I_Baseline=IRF_I;
IRF_G_Baseline=IRF_G;
IRF_Deficit_Baseline=Deficit;
IRF_K_Baseline=IRF_K;
IRF_M_Baseline=IRF_M;
IRF_N_Baseline=IRF_N;
IRF_S_Baseline=IRF_S;
IRF_PI_Baseline=IRF_PI;
IRF_RB_Baseline=IRF_RB;
IRF_RBREAL_Baseline=IRF_RBREAL;
IRF_Q_Baseline=IRF_Q;
IRF_D_Baseline=IRF_D;
IRF_LP_Baseline=IRF_LP;

%%
load KS_IRF_data
IRF_Y_minus=IRF_Y_KS(1:end-1);
IRF_C_minus=IRF_C_KS(1:end-1);
IRF_I_minus=IRF_I_KS(1:end-1);
IRF_G_minus=IRF_G_KS(1:end-1);
IRF_Deficit_minus=IRF_Deficit_KS(1:end-1);
IRF_K_minus=IRF_K_KS(1:end-1);
IRF_M_minus=IRF_M_KS(1:end-1);
IRF_N_minus=IRF_N_KS(1:end-1);
IRF_S_minus=IRF_S_KS(1:end-1);
IRF_PI_minus=IRF_PI_KS(1:end-1);
IRF_RB_minus=IRF_RB_KS(1:end-1);
IRF_RBREAL_minus=IRF_RBREAL_KS(1:end-1);
IRF_Q_minus=IRF_Q_KS(1:end-1);
IRF_D_minus=IRF_D_KS(1:end-1);
IRF_LP_minus=IRF_LIP_KS(1:end-1);

mpar.maxlag=39;

%% Plotting
% Output and Components
figurename=['IRF_Y_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_Y_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_Y_minus,'--','LineWidth',3.5)
legend({legend_1,legend_2},'Location','SouthEast','AutoUpdate','off')
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
plot(1:mpar.maxlag,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25);
set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_C_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_C_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_C_minus,'--','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_I_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_I_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_I_minus,'--','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_G_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_G_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_G_minus,'--','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_Deficit_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_Deficit_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_Deficit_minus,'--','LineWidth',3.5)
ylabel('Percentage Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])
%%
figurename=['IRF_K_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_K_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_K_minus,'--','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_M_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_M_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_M_minus,'--','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_S_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_S_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_S_minus,'--','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])
%%

figurename=['IRF_RB_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_RB_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_RB_minus,'--','LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_PI_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_PI_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_PI_minus,'--','LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_Q_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_Q_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_Q_minus,'--','LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_D_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_D_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_D_minus,'--','LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_LP_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_LP_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag-1,IRF_LP_minus,'--','LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])


figurename=['IRF_N_robustness_' robustness];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag,IRF_N_Baseline,'LineWidth',3.5)
hold on
plot(1:mpar.maxlag,IRF_N_minus,'--','LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])
%%
