function [c_star,m_star]=EGM_policyupdate(EVm,Rminus,Qminus,BtoK,BtoKminus,RBminus,PIminus,inc,mesh,grid,par,mpar)

%% EGM Step 1:
EMU = par.beta*reshape(EVm,[mpar.nm,mpar.nh]);%reshape(reshape(Vm,[mpar.nm*mpar.nk,mpar.nh])*P',[mpar.nm,mpar.nk,mpar.nh]);
c_new = 1./(EMU.^(1/par.xi));

% Calculate assets consistent with choices being (m')
% Calculate initial money position from the budget constraint,
% that leads to the optimal consumption choice
m_star_n = (c_new + (Qminus+BtoK)*mesh.m - inc.labor);
m_star_n = m_star_n./(Rminus+Qminus+BtoKminus*RBminus/PIminus);

% Identify binding constraints
binding_constraints = mesh.m < repmat(m_star_n(1,:),[mpar.nm 1]);

% Consumption when drawing assets m' to zero: Eat all Resources
Resource = inc.labor + inc.money;

% Next step: Interpolate w_guess and c_guess from new k-grids
% using c(s,h,k'), k(s,h,k'K

m_star_n = reshape(m_star_n,[mpar.nm mpar.nh]);
c_n_aux  = reshape(c_new,[mpar.nm mpar.nh]);

% Interpolate grid.m and c_n_aux defined on m_star_n over grid.m
% Check monotonicity of m_star_n
if max(sum(abs(diff(sign(diff(m_star_n))))))~=0
    warning('non monotone future liquid asset choice encountered')
end

[c_n_star, m_n_star]=egm1b_aux_mex(grid.m,m_star_n,c_n_aux);

c_star = reshape(c_n_star,[mpar.nm, mpar.nh]);
m_star = reshape(m_n_star,[mpar.nm, mpar.nh]);

c_star(binding_constraints) = Resource(binding_constraints)-Qminus*grid.m(1);
m_star(binding_constraints) = min(grid.m);

m_star(m_n_star>grid.m(end)) = grid.m(end);

end
