close all

IRF_distr=Gamma_state*IRF_state_sparse(1:mpar.numstates-3,1:mpar.maxlag);

IRF_H=100*grid.h(1:end-1)*IRF_distr(mpar.nm+(1:mpar.nh-1),2:end)/par.H;
K=grid.m*IRF_distr((1:mpar.nm),1:end)+grid.K;
I=(K(2:end)-(1-par.delta)*K(1:end-1));
IRF_I=100*(I/(par.delta*grid.K)-1);
IRF_K=100*(K(2:end)./grid.K-1);

IRF_RB=100*100*IRF_state_sparse(mpar.numstates-os+1,2:end);
IRF_S=100*IRF_state_sparse(mpar.numstates-os+3,1:end-1);
BtoK=IRF_state_sparse(mpar.numstates-os+2,1:end)+grid.B/grid.K;

M=grid.K*BtoK;
IRF_M=100*(M(2:end)/grid.B-1);

Y=Output*(1+IRF_state_sparse(end-oc+3,1:end-1));
G=par.gamma1*(1+IRF_state_sparse(end-oc+4,1:end-1));
IRF_C=100*((Y-G-I)./(Output-par.gamma1-par.delta*grid.K)-1);
IRF_Y=100*IRF_state_sparse(end-oc+3,1:end-1);
IRF_G=100*IRF_state_sparse(end-oc+4,1:end-1);
IRF_Q=100*IRF_state_sparse(end-oc+1,1:end-1);
IRF_N=100*IRF_state_sparse(end-oc+8,1:end-1);
IRF_R=100*IRF_state_sparse(end-oc+6,1:end-1);
IRF_PI=100*100*IRF_state_sparse(end-oc+2,1:end-1);

PI=1+IRF_state_sparse(end-oc+2,1:end-1);
Q=par.Q*(1+IRF_state_sparse(end-oc+1,1:end-1));
R=par.R*(1+IRF_state_sparse(end-oc+6,1:end-1));
RB=par.RB+(IRF_state_sparse(mpar.numstates-os+1,2:end));
IRF_RBREAL=100*100*(RB./PI-par.RB);
IRF_D=100*100*((1+IRF_R/100)*par.R-par.R);

Deficit=100*(M(2:end) - M(1:end-1)./PI)./Y;

IRF_LP=100*100*(((Q(2:end)+R(2:end))./Q(1:end-1)-RB(1:end-1)./PI(2:end))-((1+par.R/par.Q)-par.RB));

%% Plotting
% Output and Components
figurename=['IRF_Y_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_Y,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black')
set(gca, 'FontName','arial','FontSize',25);
set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_C_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_C,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_I_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_I,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_G_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_G,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_Deficit_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,Deficit,'LineWidth',3.5)
ylabel('Percentage Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])
%%
figurename=['IRF_K_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_K,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_M_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_M,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_H_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_H,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_S_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_S,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])
%%
figurename=['IRF_RBPI_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_RB,'--','LineWidth',3.5)
hold on
plot(1:mpar.maxlag-1,IRF_RBREAL,'LineWidth',3.5)
hold on
legend({'nominal','real'},'Location','NorthEast')
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black','HandleVisibility','off') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_RB_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_RB,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_PI_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_PI,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_Q_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_Q,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_D_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_D,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_LP_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-2,IRF_LP,'LineWidth',3.5)
ylabel('Basis Points','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
ylim([-10 10])
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])


figurename=['IRF_N_theta2_' num2str(100*par.theta_pi)   '_gamma_pi_' num2str(100*par.gamma_pi) '_gamma_T_' num2str(10000*par.gamma_T) '_' casename  '_' aggrshock];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 750 500])
plot(1:mpar.maxlag-1,IRF_N,'LineWidth',3.5)
ylabel('Percent','Interpreter','none','FontName','arial','FontSize',25)
xlabel('Quarter','Interpreter','none','FontName','arial','FontSize',25)
hold on
plot(0:mpar.maxlag-1,zeros(1,mpar.maxlag),'--black') 
set(gca, 'FontName','arial','FontSize',25); set(gca,'Position',[0.2 0.2 0.75 0.75])
printpdf(gcf,['latex/' figurename])

